program UserFix;

{$A+,B-,D-,E-,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$IFDEF MSDOS} {$M 65520,0,0} {$ENDIF}

{$IFDEF Debug} {$D+,S+} {$ENDIF}


function FExist (filename : pChar) : boolean; assembler;

 asm
              push  ds
              lds   dx,filename
              mov   ax,$4300
              int   $21
              pop   ds
              mov   ax,0
              jc    @@1
              inc   ax
  @@1:
 end;


function IsEqual (const var1,var2; varsize : word) : boolean; assembler;

 asm
              push  ds
              lds   si,var1
              les   di,var2
              cld
              mov   cx,varsize
              xor   ax,ax
              repe  cmpsb
              jne   @@1
              inc   ax
  @@1:        pop   ds
 end;


procedure FailSave (var f : file; wasok : boolean);

 begin
  if wasok
   then writeln ('ok')
   else begin
         writeln ('nicht ok');
         close (f);
         halt;
        end;
 end;


function OpenFile (var f : file; name : pChar) : boolean;

 begin
  OpenFile:=false;
  assign (f,name);
  if not FExist (name)
   then exit;
  FileMode:=2;
  reset (f,1);
  OpenFile:=ioresult=0;
 end;


function CheckCode (var f : file; ofs : longint; const soll : array of byte) : boolean;

 var ist : array [0..1023] of byte;

 begin
  CheckCode:=false;
  seek (f,ofs);
  if ioresult<>0
   then exit;
  blockread (f,ist,high (soll)+1);
  if ioresult<>0
   then exit;
  CheckCode:=IsEqual (ist,soll,high (soll)+1)
 end;


function PatchCode (var f : file; ofs : longint; var newcode : array of byte) : boolean;

 begin
  PatchCode:=false;
  seek (f,ofs);
  if ioresult<>0
   then exit;
  blockwrite (f,newcode,high (newcode)+1);
  PatchCode:=ioresult=0;
 end;


function CopyTo (var f : file; newname : pChar) : boolean;

 var f2 : file;
     li : longint;
     a  : array [0..32767] of byte;

 begin
  CopyTo:=false;
  if FExist (newname)
   then exit;
  assign (f2,newname);
  rewrite (f2,1);
  if ioresult<>0
   then exit;
  li:=filesize (f);
  if ioresult<>0
   then exit;
  seek (f,0);
  if ioresult<>0
   then exit;
  while li>=sizeof (a) do begin
   blockread (f,a,sizeof (a));
   if ioresult<>0
    then exit;
   blockwrite (f2,a,sizeof (a));
   if ioresult<>0
    then exit;
   dec (li,sizeof (a));
  end;
  if li>0
   then begin
         blockread (f,a,li);
         if ioresult<>0
          then exit;
         blockwrite (f2,a,li);
         if ioresult<>0
          then exit;
        end;
  close (f2);
  CopyTo:=ioresult=0;
 end;


function CloseFile (var f : file) : boolean;

 begin
  close (f);
  CloseFile:=ioresult=0;
 end;



const PM16ofs = $00006A76;
      PM32ofs = PM16ofs+$019F-$0036;

      PM16old : array [0..14] of byte = ($90,$90,$90,$90,$90,$90,$66,$58,$6A,$00,$66,$50,$E9,$5A,$01);
      PM32old : array [0..15] of byte = ($55,$8B,$EC,$68,$E6,$01,$FF,$76,$12,$FF,$76,$10,$8B,$5E,$0E,$43);

      PM16new : array [0..14] of byte = ($66,$58,$6A,$00,$66,$50,$E9,$60,$01,$8B,$5E,$0E,$FC,$C3,$90);
      PM32new : array [0..15] of byte = ($55,$8B,$EC,$68,$E6,$01,$FF,$76,$12,$FF,$76,$10,$E8,$91,$FE,$43);


var f : file;

begin
 write ('Datei USER.EXE: ');
 FailSave (f,OpenFile (f,'USER.EXE'));
 write ('Code fr PeekMessage: ');
 FailSave (f,CheckCode (f,PM16ofs,PM16old));
 write ('Code fr PeekMessage32: ');
 FailSave (f,CheckCode (f,PM32ofs,PM32old));
 write ('Sicherheitskopie OLD_USER.EXE: ');
 FailSave (f,CopyTo (f,'OLD_USER.EXE'));
 write ('Patch in PeekMessage: ');
 FailSave (f,PatchCode (f,PM16ofs,PM16new));
 write ('Patch in PeekMessage32: ');
 FailSave (f,PatchCode (f,PM32ofs,PM32new));
 write ('Abschlu: ');
 FailSave (f,CloseFile (f));
end.